Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.activeio.packet
Class ByteArrayPacket

    java.lang.Object
      org.activeio.packet.ByteArrayPacket

All Implemented Interfaces:
  Disposable, Packet

public final class ByteArrayPacket
extends java.lang.Object
implements Packet

Provides a Packet implementation that is directly backed by a `byte[]`.

Version:
  $Revision$

Nested Class Summary

Nested classes inherited from class org.activeio.Packet
`Packet.ByteSequence`

Constructor Summary
`ByteArrayPacket(byte[] buffer)`
`ByteArrayPacket(byte[] buffer, int offset, int capacity)`

Method Summary
`Packet.ByteSequence` | `asByteSequence()`
`int` | `capacity()`
`void` | `clear()`
`void` | `dispose()` This method should not throw any exceptions.
`Packet` | `duplicate()`
`java.lang.Object` | `duplicate(java.lang.ClassLoader cl)`
`void` | `flip()`
`byte[]` | `getBuffer()`
`boolean` | `hasRemaining()`
`int` | `limit()`
`void` | `limit(int limit)`
`java.lang.Object` | `narrow(java.lang.Class target)` Used to get a richer metadata interface to the packet.
`int` | `position()`
`void` | `position(int position)`
`int` | `read()`
`int` | `read(byte[] data, int offset, int length)`
`int` | `read(Packet dest)`
`int` | `remaining()`
`void` | `rewind()`
`Packet` | `slice()`
`byte[]` | `sliceAsBytes()`
`java.lang.String` | `toString()`
`int` | `write(byte[] data, int offset, int length)`
`boolean` | `write(int data)`
`void` | `writeTo(java.io.DataOutput out)`
`void` | `writeTo(java.io.OutputStream out)` Writes the remaing bytes in the packet to the output stream.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### ByteArrayPacket

    public ByteArrayPacket(byte[] buffer)

### ByteArrayPacket

    public ByteArrayPacket(byte[] buffer,
                           int offset,
                           int capacity)

Method Detail

### position

    public int position()

  Specified by:
    `position` in interface `Packet`

### position

    public void position(int position)

  Specified by:
    `position` in interface `Packet`

### limit

    public int limit()

  Specified by:
    `limit` in interface `Packet`

### limit

    public void limit(int limit)

  Specified by:
    `limit` in interface `Packet`

### flip

    public void flip()

  Specified by:
    `flip` in interface `Packet`

### remaining

    public int remaining()

  Specified by:
    `remaining` in interface `Packet`

### rewind

    public void rewind()

  Specified by:
    `rewind` in interface `Packet`

### hasRemaining

    public boolean hasRemaining()

  Specified by:
    `hasRemaining` in interface `Packet`

### clear

    public void clear()

  Specified by:
    `clear` in interface `Packet`

### capacity

    public int capacity()

  Specified by:
    `capacity` in interface `Packet`

### slice

    public Packet slice()

  Specified by:
    `slice` in interface `Packet`

### duplicate

    public Packet duplicate()

  Specified by:
    `duplicate` in interface `Packet`

### duplicate

    public java.lang.Object duplicate(java.lang.ClassLoader cl)
                               throws java.io.IOException

  Specified by:
    `duplicate` in interface `Packet`
  Throws:
    `java.io.IOException`

### writeTo

    public void writeTo(java.io.OutputStream out)
                 throws java.io.IOException

  Description copied from interface: `Packet`
  Writes the remaing bytes in the packet to the output stream.

  Specified by:
    `writeTo` in interface `Packet`
  Parameters:
    `out` -
  Returns:
  Throws:
    `java.io.IOException`

### writeTo

    public void writeTo(java.io.DataOutput out)
                 throws java.io.IOException

  Specified by:
    `writeTo` in interface `Packet`
  Throws:
    `java.io.IOException`

### read

    public int read()

  Specified by:
    `read` in interface `Packet`
  See Also:
    `Packet.read()`

### read

    public int read(byte[] data,
                    int offset,
                    int length)

  Specified by:
    `read` in interface `Packet`
  See Also:
    `Packet.read(byte[], int, int)`

### write

    public boolean write(int data)

  Specified by:
    `write` in interface `Packet`
  See Also:
    `Packet.write(int)`

### write

    public int write(byte[] data,
                     int offset,
                     int length)

  Specified by:
    `write` in interface `Packet`
  See Also:
    `Packet.write(byte[], int, int)`

### asByteSequence

    public Packet.ByteSequence asByteSequence()

  Specified by:
    `asByteSequence` in interface `Packet`

### sliceAsBytes

    public byte[] sliceAsBytes()

  Specified by:
    `sliceAsBytes` in interface `Packet`
  See Also:
    `Packet.sliceAsBytes()`

### read

    public int read(Packet dest)

  Specified by:
    `read` in interface `Packet`
  Parameters:
    `dest` -
  Returns:
    the number of bytes read into the dest.

### toString

    public java.lang.String toString()

### narrow

    public java.lang.Object narrow(java.lang.Class target)

  Description copied from interface: `Packet`
  Used to get a richer metadata interface to the packet.

  Specified by:
    `narrow` in interface `Packet`

### getBuffer

    public byte[] getBuffer()

### dispose

    public void dispose()

  Description copied from interface: `Disposable`
  This method should not throw any exceptions. Cleaning up a Disposable object should be easy of an end user therefore do not make him have to handle an Exception.

  Specified by:
    `dispose` in interface `Disposable`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © -2005 The ActiveIO Project. All Rights Reserved.